var events=require("events"),util=require("util"),async=require("async"),config=require("./config"),common=require("./common"),exception=require("./exception"),Stream=require("stream").Stream;const formatRegExp=/%[sdj%]/g;var Logger=exports.Logger=function(t){events.EventEmitter.call(this),this.configure(t)};function ProfileHandler(t){this.logger=t,this.start=Date.now()}util.inherits(Logger,events.EventEmitter),Logger.prototype.configure=function(t){var r=this;Array.isArray(this._names)&&this._names.length&&this.clear(),t=t||{},this.transports={},this._names=[],t.transports&&t.transports.forEach(function(t){r.add(t,null,!0)}),this.padLevels=t.padLevels||!1,this.setLevels(t.levels),t.colors&&config.addColors(t.colors),this.level=t.level||"info",this.emitErrs=t.emitErrs||!1,this.stripColors=t.stripColors||!1,this.exitOnError=void 0===t.exitOnError||t.exitOnError,this.exceptionHandlers={},this.profilers={},["rewriters","filters"].forEach(function(e){r[e]=Array.isArray(t[e])?t[e]:[]}),t.exceptionHandlers&&this.handleExceptions(t.exceptionHandlers)},Logger.prototype.log=function(t){for(var r=Array.prototype.slice.call(arguments,1),e=this;null===r[r.length-1];)r.pop();var o="function"==typeof r[r.length-1]?r.pop():null;function n(t){o?o(t):e.emitErrs&&e.emit("error",t)}if(0===this._names.length)return n(new Error("Cannot log with no transports."));if(void 0===e.levels[t])return n(new Error("Unknown log level: "+t));var s=this._names.filter(function(r){var o=e.transports[r];return o.level&&e.levels[o.level]>=e.levels[t]||!o.level&&e.levels[e.level]>=e.levels[t]});if(s.length){var i=Object.prototype.toString.call(r[r.length-1]),a=r[0]&&r[0].match&&r[0].match(formatRegExp),c=(a&&a.length?"[object Object]"===i:"[object Object]"===i||"[object Error]"===i||"[object Array]"===i)?r.pop():{},l=util.format.apply(null,r);if(this.padLevels&&(l=new Array(this.levelLength-t.length+1).join(" ")+l),this.rewriters.forEach(function(r){c=r(t,l,c,e)}),this.filters.forEach(function(r){var o=r(t,l,c,e);"string"==typeof o?l=o:(l=o.msg,c=o.meta)}),this.stripColors){l=(""+l).replace(/\u001b\[(\d+(;\d+)*)?m/g,"")}return async.forEach(s,function(r,o){var n=e.transports[r];n.log(t,l,c,function(r){if(r)return r.transport=n,p(r),o();e.emit("logging",n,t,l,c),o()})},p),this}function p(r){if(o){if(r)return o(r);o(null,t,l,c)}o=null,r||e.emit("logged",t,l,c)}o&&o()},Logger.prototype.query=function(t,r){"function"==typeof t&&(r=t,t={});var e,o=this,n=(t=t||{},{}),s=common.clone(t.query)||{};function i(r,e){t.query&&(t.query=r.formatQuery(s)),r.query(t,function(o,n){if(o)return e(o);e(null,r.formatResults(n,t.format))})}if(t.transport)return t.transport=t.transport.toLowerCase(),i(this.transports[t.transport],r);e=this._names.map(function(t){return o.transports[t]}).filter(function(t){return!!t.query}),async.forEach(e,function(t,r){i(t,function(e,o){r&&((o=e||o)&&(n[t.name]=o),r()),r=null})},function(){r(null,n)})},Logger.prototype.stream=function(t){var r=this,e=(t=t||{},new Stream),o=[];if(t.transport){var n=this.transports[t.transport];if(delete t.transport,n&&n.stream)return n.stream(t)}return e._streams=o,e.destroy=function(){for(var t=o.length;t--;)o[t].destroy()},this._names.map(function(t){return r.transports[t]}).filter(function(t){return!!t.stream}).forEach(function(r){var n=r.stream(t);n&&(o.push(n),n.on("log",function(t){t.transport=t.transport||[],t.transport.push(r.name),e.emit("log",t)}),n.on("error",function(t){t.transport=t.transport||[],t.transport.push(r.name),e.emit("error",t)}))}),e},Logger.prototype.close=function(){var t=this;this._names.forEach(function(r){var e=t.transports[r];e&&e.close&&e.close()}),this.emit("close")},Logger.prototype.handleExceptions=function(){var t=[],r=this;Array.prototype.slice.call(arguments).forEach(function(r){Array.isArray(r)?t=t.concat(r):t.push(r)}),this.exceptionHandlers=this.exceptionHandlers||{},t.forEach(function(t){r.exceptionHandlers[t.name]=t}),this._hnames=Object.keys(r.exceptionHandlers),this.catchExceptions||(this.catchExceptions=this._uncaughtException.bind(this),process.on("uncaughtException",this.catchExceptions))},Logger.prototype.unhandleExceptions=function(){var t=this;this.catchExceptions&&(Object.keys(this.exceptionHandlers).forEach(function(r){var e=t.exceptionHandlers[r];e.close&&e.close()}),this.exceptionHandlers={},Object.keys(this.transports).forEach(function(r){var e=t.transports[r];e.handleExceptions&&(e.handleExceptions=!1)}),process.removeListener("uncaughtException",this.catchExceptions),this.catchExceptions=!1)},Logger.prototype.add=function(t,r,e){var o=e?t:new t(r);if(!o.name&&!o.log)throw new Error("Unknown transport with no log() method");if(this.transports[o.name])throw new Error("Transport already attached: "+o.name);return this.transports[o.name]=o,this._names=Object.keys(this.transports),o._onError=this._onError.bind(this,o),e||o.on("error",o._onError),o.handleExceptions&&!this.catchExceptions&&this.handleExceptions(),this},Logger.prototype.clear=function(){Object.keys(this.transports).forEach(function(t){this.remove({name:t})},this)},Logger.prototype.remove=function(t){var r="string"!=typeof t?t.name||t.prototype.name:t;if(!this.transports[r])throw new Error("Transport "+r+" not attached to this instance");var e=this.transports[r];return delete this.transports[r],this._names=Object.keys(this.transports),e.close&&e.close(),e._onError&&e.removeListener("error",e._onError),this},Logger.prototype.startTimer=function(){return new ProfileHandler(this)},Logger.prototype.profile=function(t){var r,e,o,n,s,i=Date.now();return this.profilers[t]?(r=this.profilers[t],delete this.profilers[t],s="function"==typeof(e=Array.prototype.slice.call(arguments))[e.length-1]?e.pop():null,n="object"==typeof e[e.length-1]?e.pop():{},o=2===e.length?e[1]:t,n.durationMs=i-r,this.info(o,n,s)):(this.profilers[t]=i,this)},Logger.prototype.setLevels=function(t){return common.setLevels(this,this.levels,t)},Logger.prototype.cli=function(){return this.padLevels=!0,this.setLevels(config.cli.levels),config.addColors(config.cli.colors),this.transports.console&&(this.transports.console.colorize=this.transports.console.colorize||!0,this.transports.console.timestamp=this.transports.console.timestamp||!1),this},Logger.prototype._uncaughtException=function(t){var r,e,o=!1,n=exception.getAllInfo(t),s=this._getExceptionHandlers();function i(){e&&!o&&(clearTimeout(r),o=!0,process.exit(1))}if(e="function"==typeof this.exitOnError?this.exitOnError(t):this.exitOnError,!s||0===s.length)return i();async.forEach(s,function(r,e){r.logException("uncaughtException: "+(t.message||t),n,e,t)},i),e&&(r=setTimeout(i,3e3))},Logger.prototype._getExceptionHandlers=function(){var t=this;return this._hnames.map(function(r){return t.exceptionHandlers[r]}).concat(this._names.map(function(r){return t.transports[r].handleExceptions&&t.transports[r]})).filter(Boolean)},Logger.prototype._onError=function(t,r){this.emitErrs&&this.emit("error",r,t)},ProfileHandler.prototype.done=function(t){var r=Array.prototype.slice.call(arguments),e="function"==typeof r[r.length-1]?r.pop():null,o="object"==typeof r[r.length-1]?r.pop():{};return o.duration=Date.now()-this.start+"ms",this.logger.info(t,o,e)};