var events=require("events"),fs=require("fs"),path=require("path"),util=require("util"),async=require("async"),zlib=require("zlib"),common=require("../common"),Transport=require("./transport").Transport,isWritable=require("isstream").isWritable,Stream=require("stream").Stream,os=require("os"),File=exports.File=function(e){var t=this;function i(t){Array.prototype.slice.call(arguments,1).forEach(function(i){if(e[i])throw new Error("Cannot set "+i+" and "+t+"together")})}if(Transport.call(this,e),e.filename||e.dirname)i("filename or dirname","stream"),this._basename=this.filename=e.filename?path.basename(e.filename):"winston.log",this.dirname=e.dirname||path.dirname(e.filename),this.options=e.options||{flags:"a"},this.options.highWaterMark=this.options.highWaterMark||24;else{if(!e.stream)throw new Error("Cannot log to file without filename or stream.");i("stream","filename","maxsize"),this._stream=e.stream,this._isStreams2=isWritable(this._stream),this._stream.on("error",function(e){t.emit("error",e)}),this._stream.setMaxListeners(1/0)}this.json=!1!==e.json,this.logstash=e.logstash||!1,this.colorize=e.colorize||!1,this.maxsize=e.maxsize||null,this.rotationFormat=e.rotationFormat||!1,this.zippedArchive=e.zippedArchive||!1,this.maxFiles=e.maxFiles||null,this.prettyPrint=e.prettyPrint||!1,this.label=e.label||null,this.timestamp=null==e.timestamp||e.timestamp,this.eol=e.eol||os.EOL,this.tailable=e.tailable||!1,this.depth=e.depth||null,this.showLevel=void 0===e.showLevel||e.showLevel,this.maxRetries=e.maxRetries||2,this.json&&(this.stringify=e.stringify),this._size=0,this._created=0,this._buffer=[],this._draining=!1,this._opening=!1,this._failures=0,this._archive=null};util.inherits(File,Transport),File.prototype.name="file",File.prototype.log=function(e,t,i,r){if(this.silent)return r(null,!0);if(this._failures>=this.maxRetries)return r(new Error("Transport is in a failed state."));var s=this;"string"!=typeof t&&(t=""+t);var n=common.log({level:e,message:t,meta:i,json:this.json,logstash:this.logstash,colorize:this.colorize,prettyPrint:this.prettyPrint,timestamp:this.timestamp,showLevel:this.showLevel,stringify:this.stringify,label:this.label,depth:this.depth,formatter:this.formatter,humanReadableUnhandledException:this.humanReadableUnhandledException});"string"==typeof n&&(n+=this.eol),this.filename?this.open(function(e){if(e)return s._buffer.push([n,r]);s._write(n,r),s._size+=n.length,s._lazyDrain()}):(this._write(n,r),this._size+=n.length,this._lazyDrain())},File.prototype._write=function(e,t){if(this._isStreams2)return this._stream.write(e),t&&process.nextTick(function(){t(null,!0)});var i=this._stream.write(e);return t?!1===i?this._stream.once("drain",function(){t(null,!0)}):void process.nextTick(function(){t(null,!0)}):void 0},File.prototype.query=function(e,t){"function"==typeof e&&(t=e,e={});var i=path.join(this.dirname,this.filename),r=(e=this.normalizeQuery(e),""),s=[],n=0,a=fs.createReadStream(i,{encoding:"utf8"});function o(t,i){try{var r=JSON.parse(t);(function(t){if(!t)return;if("object"!=typeof t)return;var i=new Date(t.timestamp);if(e.from&&i<e.from||e.until&&i>e.until)return;return!0})(r)&&function(t){if(e.rows&&s.length>=e.rows)return void(a.readable&&a.destroy());if(e.fields){var i={};e.fields.forEach(function(e){i[e]=t[e]}),t=i}s.push(t)}(r)}catch(e){i||a.emit("error",e)}}a.on("error",function(e){if(a.readable&&a.destroy(),t)return"ENOENT"!==e.code?t(e):t(null,s)}),a.on("data",function(t){for(var i=(t=(r+t).split(/\n+/)).length-1,s=0;s<i;s++)(!e.start||n>=e.start)&&o(t[s]),n++;r=t[i]}),a.on("close",function(){r&&o(r,!0),"desc"===e.order&&(s=s.reverse()),t&&t(null,s)})},File.prototype.stream=function(e){var t=path.join(this.dirname,this.filename),i=(e=e||{},new Stream),r={file:t,start:e.start};return i.destroy=common.tailFile(r,function(e,t){if(e)return i.emit("error",e);try{i.emit("data",t),t=JSON.parse(t),i.emit("log",t)}catch(e){i.emit("error",e)}}),i},File.prototype.open=function(e){return this.opening?e(!0):!this._stream||this.maxsize&&this._size>=this.maxsize?(e(!0),this._createStream()):(this._archive=this.zippedArchive?this._stream.path:null,void e())},File.prototype.close=function(){var e=this;this._stream&&(this._stream.end(),this._stream.destroySoon(),this._stream.once("finish",function(){e.emit("flush"),e.emit("closed")}))},File.prototype.flush=function(){var e=this;if(!this._buffer.length)return e.emit("flush");this._buffer.forEach(function(t){var i=t[0],r=t[1];process.nextTick(function(){e._write(i,r),e._size+=i.length})}),e._buffer.length=0,e._stream.once("drain",function(){e.emit("flush"),e.emit("logged")})},File.prototype._createStream=function(){var e=this;this.opening=!0,function t(i){var r=path.join(e.dirname,i);function s(t){e._stream&&(e._stream.end(),e._stream.destroySoon()),e._size=t,e.filename=i,e._stream=fs.createWriteStream(r,e.options),e._isStreams2=isWritable(e._stream),e._stream.on("error",function(t){e._failures<e.maxRetries?(e._createStream(),e._failures++):e.emit("error",t)}),e._stream.setMaxListeners(1/0),e.once("flush",function(){e.flush(),e.opening=!1,e.emit("open",r)}),e.flush(),function(){if(e._archive){var t=zlib.createGzip(),i=fs.createReadStream(String(e._archive)),r=fs.createWriteStream(e._archive+".gz");i.pipe(t).pipe(r),fs.unlink(String(e._archive)),e._archive=""}}()}fs.stat(r,function(i,r){return i?"ENOENT"!==i.code?e.emit("error",i):s(0):!r||e.maxsize&&r.size>=e.maxsize?e._incFile(function(){t(e._getFile())}):void s(r.size)})}(this._getFile())},File.prototype._incFile=function(e){var t=path.extname(this._basename),i=path.basename(this._basename,t);this.tailable?this._checkMaxFilesTailable(t,i,e):(this._created+=1,this._checkMaxFilesIncrementing(t,i,e))},File.prototype._getFile=function(){var e=path.extname(this._basename),t=path.basename(this._basename,e);return!this.tailable&&this._created?t+(this.rotationFormat?this.rotationFormat():this._created)+e:t+e},File.prototype._checkMaxFilesIncrementing=function(e,t,i){var r,s;if(this.zippedArchive&&(this._archive=path.join(this.dirname,t+(1===this._created?"":this._created-1)+e)),!this.maxFiles||this._created<this.maxFiles)return i();r=this._created-this.maxFiles,s=path.join(this.dirname,t+(0!==r?r:"")+e+(this.zippedArchive?".gz":"")),fs.unlink(s,i)},File.prototype._checkMaxFilesTailable=function(e,t,i){var r=[],s=this;if(this.maxFiles){for(var n=this.maxFiles-1;n>0;n--)r.push(function(i){return function(r){var n=path.join(s.dirname,t+(i-1)+e+(s.zippedArchive?".gz":""));fs.exists(n,function(a){if(!a)return r(null);fs.rename(n,path.join(s.dirname,t+i+e+(s.zippedArchive?".gz":"")),r)})}}(n));s.zippedArchive&&(s._archive=path.join(s.dirname,t+1+e)),async.series(r,function(r){fs.rename(path.join(s.dirname,t+e),path.join(s.dirname,t+1+e),i)})}},File.prototype._lazyDrain=function(){var e=this;!this._draining&&this._stream&&(this._draining=!0,this._stream.once("drain",function(){this._draining=!1,e.emit("logged")}))};